/*
 * File         : Jacobi_s.java
 * Author       : Guansong Zhang
 * Created      : Mon Feb  2 10:36:02 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1998/02/20 17:01:49 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

import spmd.*;

class Jacobi_s {

  static final int n=1024;

  public static void main(String argv[]) {
    float a [][] = new float [n][n];

    int i, j;

    for (i=0; i<n; i++) {
      for (j=0; j<n; j++) {
	if (i==0 || i==n-1 || j==0 || j==n-1)
	  a[i][j]=1;
	else
	  a[i][j]=0;
      }
    }

    /*
    for (i=0; i<n; i++) {
      for (j=0; j<n; j++) {
	System.out.print(a[i][j]+" ");
      };
    
      System.out.println();
    }
    */

    float b [][] = new float [n][n];

    for (int iter=0; iter <100; iter++) {

      if (iter==10)
	Clock.start();


      /* this will use memcpy cause system overhead on solaris 2.5.1
      for (i=0; i<n; i++) {
	for (j=0; j<n; j++) {      

	  b[i][j]=a[i][j];
	}
      }
      */

      for (i=1; i<n-1; i++) {
	for (j=1; j<n-1; j++) {

	  b[i][j]=a[i][j];
	}
      }

      for (i=1; i<n-1; i++) {
	for (j=1; j<n-1; j++) {

	  a[i][j]=((b[i-1][j]+b[i+1][j]+b[i][j-1]+b[i][j+1])*(float)0.25);
	}
      }
    }

    Clock.stop();

    /*
    for (i=0; i<n; i++) {
      for (j=0; j<n; j++) {
	System.out.print(a[i][j]+" ");
      };
    
      System.out.println();
    }
    */
  }
}
